/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.functions.util;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.EObjectValidator;
import tools.descartes.dml.mm.applicationlevel.functions.Atom;
import tools.descartes.dml.mm.applicationlevel.functions.BinaryBooleanExpression;
import tools.descartes.dml.mm.applicationlevel.functions.BoolSample;
import tools.descartes.dml.mm.applicationlevel.functions.BoolSampleList;
import tools.descartes.dml.mm.applicationlevel.functions.BooleanLiteral;
import tools.descartes.dml.mm.applicationlevel.functions.BooleanOperation;
import tools.descartes.dml.mm.applicationlevel.functions.BoxedPDF;
import tools.descartes.dml.mm.applicationlevel.functions.CompareOperation;
import tools.descartes.dml.mm.applicationlevel.functions.Comparison;
import tools.descartes.dml.mm.applicationlevel.functions.ContinuousPDF;
import tools.descartes.dml.mm.applicationlevel.functions.ContinuousSample;
import tools.descartes.dml.mm.applicationlevel.functions.DoubleLiteral;
import tools.descartes.dml.mm.applicationlevel.functions.DoubleSample;
import tools.descartes.dml.mm.applicationlevel.functions.DoubleSampleList;
import tools.descartes.dml.mm.applicationlevel.functions.EmpiricalDescription;
import tools.descartes.dml.mm.applicationlevel.functions.EnumSample;
import tools.descartes.dml.mm.applicationlevel.functions.EnumSampleList;
import tools.descartes.dml.mm.applicationlevel.functions.ExplicitDescription;
import tools.descartes.dml.mm.applicationlevel.functions.ExponentialDistribution;
import tools.descartes.dml.mm.applicationlevel.functions.Expression;
import tools.descartes.dml.mm.applicationlevel.functions.Function;
import tools.descartes.dml.mm.applicationlevel.functions.FunctionsPackage;
import tools.descartes.dml.mm.applicationlevel.functions.IfElseExpression;
import tools.descartes.dml.mm.applicationlevel.functions.InfluencingParameterValue;
import tools.descartes.dml.mm.applicationlevel.functions.IntLiteral;
import tools.descartes.dml.mm.applicationlevel.functions.IntSample;
import tools.descartes.dml.mm.applicationlevel.functions.IntSampleList;
import tools.descartes.dml.mm.applicationlevel.functions.Literal;
import tools.descartes.dml.mm.applicationlevel.functions.NormalDistribution;
import tools.descartes.dml.mm.applicationlevel.functions.Power;
import tools.descartes.dml.mm.applicationlevel.functions.ProbabilityDensityFunction;
import tools.descartes.dml.mm.applicationlevel.functions.ProbabilityFunction;
import tools.descartes.dml.mm.applicationlevel.functions.ProbabilityMassFunction;
import tools.descartes.dml.mm.applicationlevel.functions.Product;
import tools.descartes.dml.mm.applicationlevel.functions.ProductOperation;
import tools.descartes.dml.mm.applicationlevel.functions.RandomVariable;
import tools.descartes.dml.mm.applicationlevel.functions.ReplayFile;
import tools.descartes.dml.mm.applicationlevel.functions.Sample;
import tools.descartes.dml.mm.applicationlevel.functions.SampleList;
import tools.descartes.dml.mm.applicationlevel.functions.Term;
import tools.descartes.dml.mm.applicationlevel.functions.TermOperation;
import tools.descartes.dml.mm.applicationlevel.functions.UnaryBooleanExpression;

/**
 * <!-- begin-user-doc --> The <b>Validator</b> for the model. <!-- end-user-doc
 * -->
 * 
 * @see tools.descartes.dml.mm.applicationlevel.functions.FunctionsPackage
 * @generated
 */
public class FunctionsValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final FunctionsValidator INSTANCE = new FunctionsValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "tools.descartes.dml.mm.applicationlevel.functions";

	/**
	 * A constant with a fixed name that can be used as the base value for
	 * additional hand written constants. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public FunctionsValidator() {
		super();
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return FunctionsPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		switch (classifierID) {
			case FunctionsPackage.EXPRESSION:
				return validateExpression((Expression)value, diagnostics, context);
			case FunctionsPackage.EXPLICIT_DESCRIPTION:
				return validateExplicitDescription((ExplicitDescription)value, diagnostics, context);
			case FunctionsPackage.FUNCTION:
				return validateFunction((Function)value, diagnostics, context);
			case FunctionsPackage.INFLUENCING_PARAMETER_VALUE:
				return validateInfluencingParameterValue((InfluencingParameterValue)value, diagnostics, context);
			case FunctionsPackage.ATOM:
				return validateAtom((Atom)value, diagnostics, context);
			case FunctionsPackage.IF_ELSE_EXPRESSION:
				return validateIfElseExpression((IfElseExpression)value, diagnostics, context);
			case FunctionsPackage.BINARY_BOOLEAN_EXPRESSION:
				return validateBinaryBooleanExpression((BinaryBooleanExpression)value, diagnostics, context);
			case FunctionsPackage.UNARY_BOOLEAN_EXPRESSION:
				return validateUnaryBooleanExpression((UnaryBooleanExpression)value, diagnostics, context);
			case FunctionsPackage.COMPARISON:
				return validateComparison((Comparison)value, diagnostics, context);
			case FunctionsPackage.TERM:
				return validateTerm((Term)value, diagnostics, context);
			case FunctionsPackage.PRODUCT:
				return validateProduct((Product)value, diagnostics, context);
			case FunctionsPackage.POWER:
				return validatePower((Power)value, diagnostics, context);
			case FunctionsPackage.RANDOM_VARIABLE:
				return validateRandomVariable((RandomVariable)value, diagnostics, context);
			case FunctionsPackage.PROBABILITY_FUNCTION:
				return validateProbabilityFunction((ProbabilityFunction)value, diagnostics, context);
			case FunctionsPackage.LITERAL:
				return validateLiteral((Literal)value, diagnostics, context);
			case FunctionsPackage.BOOLEAN_LITERAL:
				return validateBooleanLiteral((BooleanLiteral)value, diagnostics, context);
			case FunctionsPackage.INT_LITERAL:
				return validateIntLiteral((IntLiteral)value, diagnostics, context);
			case FunctionsPackage.DOUBLE_LITERAL:
				return validateDoubleLiteral((DoubleLiteral)value, diagnostics, context);
			case FunctionsPackage.PROBABILITY_MASS_FUNCTION:
				return validateProbabilityMassFunction((ProbabilityMassFunction)value, diagnostics, context);
			case FunctionsPackage.SAMPLE_LIST:
				return validateSampleList((SampleList)value, diagnostics, context);
			case FunctionsPackage.SAMPLE:
				return validateSample((Sample)value, diagnostics, context);
			case FunctionsPackage.DOUBLE_SAMPLE:
				return validateDoubleSample((DoubleSample)value, diagnostics, context);
			case FunctionsPackage.INT_SAMPLE:
				return validateIntSample((IntSample)value, diagnostics, context);
			case FunctionsPackage.BOOL_SAMPLE:
				return validateBoolSample((BoolSample)value, diagnostics, context);
			case FunctionsPackage.ENUM_SAMPLE:
				return validateEnumSample((EnumSample)value, diagnostics, context);
			case FunctionsPackage.INT_SAMPLE_LIST:
				return validateIntSampleList((IntSampleList)value, diagnostics, context);
			case FunctionsPackage.DOUBLE_SAMPLE_LIST:
				return validateDoubleSampleList((DoubleSampleList)value, diagnostics, context);
			case FunctionsPackage.BOOL_SAMPLE_LIST:
				return validateBoolSampleList((BoolSampleList)value, diagnostics, context);
			case FunctionsPackage.ENUM_SAMPLE_LIST:
				return validateEnumSampleList((EnumSampleList)value, diagnostics, context);
			case FunctionsPackage.PROBABILITY_DENSITY_FUNCTION:
				return validateProbabilityDensityFunction((ProbabilityDensityFunction)value, diagnostics, context);
			case FunctionsPackage.REPLAY_FILE:
				return validateReplayFile((ReplayFile)value, diagnostics, context);
			case FunctionsPackage.BOXED_PDF:
				return validateBoxedPDF((BoxedPDF)value, diagnostics, context);
			case FunctionsPackage.CONTINUOUS_SAMPLE:
				return validateContinuousSample((ContinuousSample)value, diagnostics, context);
			case FunctionsPackage.CONTINUOUS_PDF:
				return validateContinuousPDF((ContinuousPDF)value, diagnostics, context);
			case FunctionsPackage.NORMAL_DISTRIBUTION:
				return validateNormalDistribution((NormalDistribution)value, diagnostics, context);
			case FunctionsPackage.EXPONENTIAL_DISTRIBUTION:
				return validateExponentialDistribution((ExponentialDistribution)value, diagnostics, context);
			case FunctionsPackage.EMPIRICAL_DESCRIPTION:
				return validateEmpiricalDescription((EmpiricalDescription)value, diagnostics, context);
			case FunctionsPackage.PRODUCT_OPERATION:
				return validateProductOperation((ProductOperation)value, diagnostics, context);
			case FunctionsPackage.TERM_OPERATION:
				return validateTermOperation((TermOperation)value, diagnostics, context);
			case FunctionsPackage.COMPARE_OPERATION:
				return validateCompareOperation((CompareOperation)value, diagnostics, context);
			case FunctionsPackage.BOOLEAN_OPERATION:
				return validateBooleanOperation((BooleanOperation)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExpression(Expression expression, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(expression, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExplicitDescription(ExplicitDescription explicitDescription, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(explicitDescription, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateFunction(Function function, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(function, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInfluencingParameterValue(InfluencingParameterValue influencingParameterValue,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(influencingParameterValue, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAtom(Atom atom, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(atom, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateIfElseExpression(IfElseExpression ifElseExpression, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(ifElseExpression, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBinaryBooleanExpression(BinaryBooleanExpression binaryBooleanExpression,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(binaryBooleanExpression, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateUnaryBooleanExpression(UnaryBooleanExpression unaryBooleanExpression,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(unaryBooleanExpression, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComparison(Comparison comparison, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(comparison, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateTerm(Term term, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(term, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateProduct(Product product, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(product, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePower(Power power, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(power, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRandomVariable(RandomVariable randomVariable, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(randomVariable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateProbabilityFunction(ProbabilityFunction probabilityFunction, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(probabilityFunction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateLiteral(Literal literal, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(literal, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBooleanLiteral(BooleanLiteral booleanLiteral, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(booleanLiteral, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateIntLiteral(IntLiteral intLiteral, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(intLiteral, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(intLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validateIntLiteral_ValueMustBeGreaterThanZero(intLiteral, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the ValueMustBeGreaterThanZero constraint of '<em>Int Literal</em>'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected static final String INT_LITERAL__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.value >= 0";

	/**
	 * Validates the ValueMustBeGreaterThanZero constraint of '<em>Int Literal</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateIntLiteral_ValueMustBeGreaterThanZero(IntLiteral intLiteral, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.INT_LITERAL,
				 intLiteral,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "ValueMustBeGreaterThanZero",
				 INT_LITERAL__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDoubleLiteral(DoubleLiteral doubleLiteral, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(doubleLiteral, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(doubleLiteral, diagnostics, context);
		if (result || diagnostics != null) result &= validateDoubleLiteral_ValueMustBeGreaterThanZero(doubleLiteral, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the ValueMustBeGreaterThanZero constraint of '<em>Double Literal</em>'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected static final String DOUBLE_LITERAL__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.value >= 0";

	/**
	 * Validates the ValueMustBeGreaterThanZero constraint of '<em>Double Literal</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDoubleLiteral_ValueMustBeGreaterThanZero(DoubleLiteral doubleLiteral,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.DOUBLE_LITERAL,
				 doubleLiteral,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "ValueMustBeGreaterThanZero",
				 DOUBLE_LITERAL__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateProbabilityMassFunction(ProbabilityMassFunction probabilityMassFunction,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(probabilityMassFunction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSampleList(SampleList sampleList, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(sampleList, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSample(Sample sample, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(sample, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(sample, diagnostics, context);
		if (result || diagnostics != null) result &= validateSample_ProbabilityMustBePositive(sample, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the ProbabilityMustBePositive constraint of '<em>Sample</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String SAMPLE__PROBABILITY_MUST_BE_POSITIVE__EEXPRESSION = "self.probability >= 0";

	/**
	 * Validates the ProbabilityMustBePositive constraint of '<em>Sample</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateSample_ProbabilityMustBePositive(Sample sample, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.SAMPLE,
				 sample,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "ProbabilityMustBePositive",
				 SAMPLE__PROBABILITY_MUST_BE_POSITIVE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDoubleSample(DoubleSample doubleSample, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(doubleSample, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validateSample_ProbabilityMustBePositive(doubleSample, diagnostics, context);
		if (result || diagnostics != null) result &= validateDoubleSample_ValueMustBeGreaterThanZero(doubleSample, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the ValueMustBeGreaterThanZero constraint of '<em>Double Sample</em>'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected static final String DOUBLE_SAMPLE__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.value >= 0";

	/**
	 * Validates the ValueMustBeGreaterThanZero constraint of '<em>Double Sample</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDoubleSample_ValueMustBeGreaterThanZero(DoubleSample doubleSample,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.DOUBLE_SAMPLE,
				 doubleSample,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "ValueMustBeGreaterThanZero",
				 DOUBLE_SAMPLE__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateIntSample(IntSample intSample, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(intSample, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validateSample_ProbabilityMustBePositive(intSample, diagnostics, context);
		if (result || diagnostics != null) result &= validateIntSample_ValueMustBeGreaterThanZero(intSample, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the ValueMustBeGreaterThanZero constraint of '<em>Int Sample</em>'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected static final String INT_SAMPLE__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.value >= 0";

	/**
	 * Validates the ValueMustBeGreaterThanZero constraint of '<em>Int Sample</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateIntSample_ValueMustBeGreaterThanZero(IntSample intSample, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.INT_SAMPLE,
				 intSample,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "ValueMustBeGreaterThanZero",
				 INT_SAMPLE__VALUE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBoolSample(BoolSample boolSample, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(boolSample, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(boolSample, diagnostics, context);
		if (result || diagnostics != null) result &= validateSample_ProbabilityMustBePositive(boolSample, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEnumSample(EnumSample enumSample, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(enumSample, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(enumSample, diagnostics, context);
		if (result || diagnostics != null) result &= validateSample_ProbabilityMustBePositive(enumSample, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateIntSampleList(IntSampleList intSampleList, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(intSampleList, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(intSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validateIntSampleList_SumOverProbabilitiesOfSamplesMustBeOne(intSampleList, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Int Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String INT_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION = "self.items.probability->sum() = 1";

	/**
	 * Validates the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Int Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateIntSampleList_SumOverProbabilitiesOfSamplesMustBeOne(IntSampleList intSampleList,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.INT_SAMPLE_LIST,
				 intSampleList,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SumOverProbabilitiesOfSamplesMustBeOne",
				 INT_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDoubleSampleList(DoubleSampleList doubleSampleList, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(doubleSampleList, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(doubleSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validateDoubleSampleList_SumOverProbabilitiesOfSamplesMustBeOne(doubleSampleList, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Double Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String DOUBLE_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION = "self.items.probability->sum() = 1";

	/**
	 * Validates the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Double Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDoubleSampleList_SumOverProbabilitiesOfSamplesMustBeOne(DoubleSampleList doubleSampleList,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.DOUBLE_SAMPLE_LIST,
				 doubleSampleList,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SumOverProbabilitiesOfSamplesMustBeOne",
				 DOUBLE_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBoolSampleList(BoolSampleList boolSampleList, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(boolSampleList, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(boolSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validateBoolSampleList_SumOverProbabilitiesOfSamplesMustBeOne(boolSampleList, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Bool Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String BOOL_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION = "self.items.probability->sum() = 1";

	/**
	 * Validates the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Bool Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBoolSampleList_SumOverProbabilitiesOfSamplesMustBeOne(BoolSampleList boolSampleList,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.BOOL_SAMPLE_LIST,
				 boolSampleList,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SumOverProbabilitiesOfSamplesMustBeOne",
				 BOOL_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEnumSampleList(EnumSampleList enumSampleList, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(enumSampleList, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(enumSampleList, diagnostics, context);
		if (result || diagnostics != null) result &= validateEnumSampleList_SumOverProbabilitiesOfSamplesMustBeOne(enumSampleList, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Enum Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String ENUM_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION = "self.items.probability->sum() = 1";

	/**
	 * Validates the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Enum Sample List</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEnumSampleList_SumOverProbabilitiesOfSamplesMustBeOne(EnumSampleList enumSampleList,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.ENUM_SAMPLE_LIST,
				 enumSampleList,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SumOverProbabilitiesOfSamplesMustBeOne",
				 ENUM_SAMPLE_LIST__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateProbabilityDensityFunction(ProbabilityDensityFunction probabilityDensityFunction,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(probabilityDensityFunction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateReplayFile(ReplayFile replayFile, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(replayFile, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBoxedPDF(BoxedPDF boxedPDF, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(boxedPDF, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validateBoxedPDF_SumOverProbabilitiesOfSamplesMustBeOne(boxedPDF, diagnostics, context);
		if (result || diagnostics != null) result &= validateBoxedPDF_SamplesMustBeSortedByValues(boxedPDF, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Boxed PDF</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String BOXED_PDF__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION = "self.sample.probability->sum() > 1 - 0.001 and self.sample.probability->sum() < 1+0.001";

	/**
	 * Validates the SumOverProbabilitiesOfSamplesMustBeOne constraint of '<em>Boxed PDF</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBoxedPDF_SumOverProbabilitiesOfSamplesMustBeOne(BoxedPDF boxedPDF,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.BOXED_PDF,
				 boxedPDF,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SumOverProbabilitiesOfSamplesMustBeOne",
				 BOXED_PDF__SUM_OVER_PROBABILITIES_OF_SAMPLES_MUST_BE_ONE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * The cached validation expression for the SamplesMustBeSortedByValues constraint of '<em>Boxed PDF</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String BOXED_PDF__SAMPLES_MUST_BE_SORTED_BY_VALUES__EEXPRESSION = "self.sample->sortedBy(value) = self.sample";

	/**
	 * Validates the SamplesMustBeSortedByValues constraint of '<em>Boxed PDF</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBoxedPDF_SamplesMustBeSortedByValues(BoxedPDF boxedPDF, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.BOXED_PDF,
				 boxedPDF,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SamplesMustBeSortedByValues",
				 BOXED_PDF__SAMPLES_MUST_BE_SORTED_BY_VALUES__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateContinuousSample(ContinuousSample continuousSample, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(continuousSample, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(continuousSample, diagnostics, context);
		if (result || diagnostics != null) result &= validateContinuousSample_ProbabilityMustBePositive(continuousSample, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the ProbabilityMustBePositive constraint
	 * of '<em>Continuous Sample</em>'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected static final String CONTINUOUS_SAMPLE__PROBABILITY_MUST_BE_POSITIVE__EEXPRESSION = "self.probability >= 0";

	/**
	 * Validates the ProbabilityMustBePositive constraint of '<em>Continuous Sample</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateContinuousSample_ProbabilityMustBePositive(ContinuousSample continuousSample,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.CONTINUOUS_SAMPLE,
				 continuousSample,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "ProbabilityMustBePositive",
				 CONTINUOUS_SAMPLE__PROBABILITY_MUST_BE_POSITIVE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateContinuousPDF(ContinuousPDF continuousPDF, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(continuousPDF, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNormalDistribution(NormalDistribution normalDistribution, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(normalDistribution, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validateNormalDistribution_SigmaMustBePositive(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validateNormalDistribution_MeanMustBeGreaterThanZero(normalDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validateNormalDistribution_DistanceOfMeanToFourTimesSigmaMustBeGreaterThanZero(normalDistribution, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SigmaMustBePositive constraint of '<em>Normal Distribution</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String NORMAL_DISTRIBUTION__SIGMA_MUST_BE_POSITIVE__EEXPRESSION = "self.sigma >= 0";

	/**
	 * Validates the SigmaMustBePositive constraint of '<em>Normal Distribution</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNormalDistribution_SigmaMustBePositive(NormalDistribution normalDistribution,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.NORMAL_DISTRIBUTION,
				 normalDistribution,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SigmaMustBePositive",
				 NORMAL_DISTRIBUTION__SIGMA_MUST_BE_POSITIVE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * The cached validation expression for the MeanMustBeGreaterThanZero constraint of '<em>Normal Distribution</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String NORMAL_DISTRIBUTION__MEAN_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.mu >= 0";

	/**
	 * Validates the MeanMustBeGreaterThanZero constraint of '<em>Normal Distribution</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNormalDistribution_MeanMustBeGreaterThanZero(NormalDistribution normalDistribution,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.NORMAL_DISTRIBUTION,
				 normalDistribution,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "MeanMustBeGreaterThanZero",
				 NORMAL_DISTRIBUTION__MEAN_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * The cached validation expression for the DistanceOfMeanToFourTimesSigmaMustBeGreaterThanZero constraint of '<em>Normal Distribution</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String NORMAL_DISTRIBUTION__DISTANCE_OF_MEAN_TO_FOUR_TIMES_SIGMA_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.mu - (4 * self.sigma) > 0";

	/**
	 * Validates the DistanceOfMeanToFourTimesSigmaMustBeGreaterThanZero constraint
	 * of '<em>Normal Distribution</em>'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public boolean validateNormalDistribution_DistanceOfMeanToFourTimesSigmaMustBeGreaterThanZero(
			NormalDistribution normalDistribution, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.NORMAL_DISTRIBUTION,
				 normalDistribution,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "DistanceOfMeanToFourTimesSigmaMustBeGreaterThanZero",
				 NORMAL_DISTRIBUTION__DISTANCE_OF_MEAN_TO_FOUR_TIMES_SIGMA_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExponentialDistribution(ExponentialDistribution exponentialDistribution,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(exponentialDistribution, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(exponentialDistribution, diagnostics, context);
		if (result || diagnostics != null) result &= validateExponentialDistribution_RateMustBeGreaterThanZero(exponentialDistribution, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the RateMustBeGreaterThanZero constraint of '<em>Exponential Distribution</em>'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected static final String EXPONENTIAL_DISTRIBUTION__RATE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.rate >= 0";

	/**
	 * Validates the RateMustBeGreaterThanZero constraint of '<em>Exponential Distribution</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExponentialDistribution_RateMustBeGreaterThanZero(
			ExponentialDistribution exponentialDistribution, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(FunctionsPackage.Literals.EXPONENTIAL_DISTRIBUTION,
				 exponentialDistribution,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "RateMustBeGreaterThanZero",
				 EXPONENTIAL_DISTRIBUTION__RATE_MUST_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEmpiricalDescription(EmpiricalDescription empiricalDescription, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(empiricalDescription, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateProductOperation(ProductOperation productOperation, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateTermOperation(TermOperation termOperation, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCompareOperation(CompareOperation compareOperation, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBooleanOperation(BooleanOperation booleanOperation, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} // FunctionsValidator
