package tools.descartes.dml.mm.applicationlevel.functions.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.impl.ExtensibleURIConverterImpl;

import tools.descartes.dml.mm.applicationlevel.functions.ReplayFile;

public class RandomVariableUtils {
	public static Collection<Double> collectSamples(ReplayFile replay) throws IOException {
		List<Double> samples = new ArrayList<Double>();
		InputStreamReader isr;
		isr = createInputStreamReaderFor(replay);
		BufferedReader br = new BufferedReader(isr);
		while (br.ready()) {
			samples.add(Double.parseDouble(br.readLine()));
		}
		br.close();
		return samples;
	}

	private static InputStreamReader createInputStreamReaderFor(ReplayFile replay) throws IOException {
		InputStreamReader isr;
		File fileOnDisk = new File(replay.getFilepath());
		if (fileOnDisk.isAbsolute()) {
			isr = new FileReader(fileOnDisk);
		} else {
			ExtensibleURIConverterImpl uriConverter = new ExtensibleURIConverterImpl();
			URI relativeReplayFileURI = URI.createHierarchicalURI(replay.getFilepath().split("/"), null, null);
			URI absoluteReplayFileURI = relativeReplayFileURI.resolve(replay.eResource().getURI());
			isr = new InputStreamReader(uriConverter.createInputStream(absoluteReplayFileURI));
		}
		return isr;
	}
}
