/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import tools.descartes.dml.core.CorePackage;
import tools.descartes.dml.identifier.IdentifierPackage;
import tools.descartes.dml.mm.applicationlevel.functions.FunctionsPackage;
import tools.descartes.dml.mm.applicationlevel.functions.impl.FunctionsPackageImpl;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.CallParameter;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ComponentInstanceReference;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ControlFlowVariable;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.DependencyRelationship;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallParameter;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.InfluencableModelVariable;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariable;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesFactory;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.Scope;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ScopeSet;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceInputParameter;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ServiceOutputParameter;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ShadowParameter;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.util.ParameterdependenciesValidator;
import tools.descartes.dml.mm.applicationlevel.repository.RepositoryPackage;
import tools.descartes.dml.mm.applicationlevel.repository.impl.RepositoryPackageImpl;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.impl.ServicebehaviorPackageImpl;
import tools.descartes.dml.mm.applicationlevel.system.SystemPackage;
import tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl;
import tools.descartes.dml.mm.resourcetype.ResourcetypePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ParameterdependenciesPackageImpl extends EPackageImpl implements ParameterdependenciesPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scopeSetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scopeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass controlFlowVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass shadowParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass relationshipEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dependencyRelationshipEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dependencyPropagationRelationshipEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentInstanceReferenceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceInputParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceOutputParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass externalCallReturnParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass externalCallParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass influencableModelVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum modelVariableCharacterizationTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum relationshipCharacterizationTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum parameterCharacterizationTypeEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private ParameterdependenciesPackageImpl() {
		super(eNS_URI, ParameterdependenciesFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 *
	 * <p>This method is used to initialize {@link ParameterdependenciesPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static ParameterdependenciesPackage init() {
		if (isInited) return (ParameterdependenciesPackage)EPackage.Registry.INSTANCE.getEPackage(ParameterdependenciesPackage.eNS_URI);

		// Obtain or create and register package
		Object registeredParameterdependenciesPackage = EPackage.Registry.INSTANCE.get(eNS_URI);
		ParameterdependenciesPackageImpl theParameterdependenciesPackage = registeredParameterdependenciesPackage instanceof ParameterdependenciesPackageImpl ? (ParameterdependenciesPackageImpl)registeredParameterdependenciesPackage : new ParameterdependenciesPackageImpl();

		isInited = true;

		// Initialize simple dependencies
		CorePackage.eINSTANCE.eClass();
		IdentifierPackage.eINSTANCE.eClass();
		ResourcetypePackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		Object registeredPackage = EPackage.Registry.INSTANCE.getEPackage(FunctionsPackage.eNS_URI);
		FunctionsPackageImpl theFunctionsPackage = (FunctionsPackageImpl)(registeredPackage instanceof FunctionsPackageImpl ? registeredPackage : FunctionsPackage.eINSTANCE);
		registeredPackage = EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);
		RepositoryPackageImpl theRepositoryPackage = (RepositoryPackageImpl)(registeredPackage instanceof RepositoryPackageImpl ? registeredPackage : RepositoryPackage.eINSTANCE);
		registeredPackage = EPackage.Registry.INSTANCE.getEPackage(ServicebehaviorPackage.eNS_URI);
		ServicebehaviorPackageImpl theServicebehaviorPackage = (ServicebehaviorPackageImpl)(registeredPackage instanceof ServicebehaviorPackageImpl ? registeredPackage : ServicebehaviorPackage.eINSTANCE);
		registeredPackage = EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI);
		SystemPackageImpl theSystemPackage = (SystemPackageImpl)(registeredPackage instanceof SystemPackageImpl ? registeredPackage : SystemPackage.eINSTANCE);

		// Create package meta-data objects
		theParameterdependenciesPackage.createPackageContents();
		theFunctionsPackage.createPackageContents();
		theRepositoryPackage.createPackageContents();
		theServicebehaviorPackage.createPackageContents();
		theSystemPackage.createPackageContents();

		// Initialize created meta-data
		theParameterdependenciesPackage.initializePackageContents();
		theFunctionsPackage.initializePackageContents();
		theRepositoryPackage.initializePackageContents();
		theServicebehaviorPackage.initializePackageContents();
		theSystemPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put
			(theParameterdependenciesPackage,
			 new EValidator.Descriptor() {
				 @Override
				public EValidator getEValidator() {
					 return ParameterdependenciesValidator.INSTANCE;
				 }
			 });

		// Mark meta-data to indicate it can't be changed
		theParameterdependenciesPackage.freeze();

		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(ParameterdependenciesPackage.eNS_URI, theParameterdependenciesPackage);
		return theParameterdependenciesPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getModelVariable() {
		return modelVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getModelVariable_ScopeSet() {
		return (EReference)modelVariableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getScopeSet() {
		return scopeSetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getScopeSet_Scope() {
		return (EReference)scopeSetEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getScope() {
		return scopeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getScope_Scope() {
		return (EReference)scopeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getControlFlowVariable() {
		return controlFlowVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getShadowParameter() {
		return shadowParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getShadowParameter_Name() {
		return (EAttribute)shadowParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getShadowParameter_Description() {
		return (EAttribute)shadowParameterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getRelationship() {
		return relationshipEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getRelationship_EmpiricalDescription() {
		return (EReference)relationshipEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getRelationship_ExplicitDescription() {
		return (EReference)relationshipEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getRelationship_Characterization() {
		return (EAttribute)relationshipEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getRelationship_Dependent() {
		return (EReference)relationshipEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getRelationship_Independent() {
		return (EReference)relationshipEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getDependencyRelationship() {
		return dependencyRelationshipEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getDependencyPropagationRelationship() {
		return dependencyPropagationRelationshipEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getDependencyPropagationRelationship_IndependentComponentInstanceReferences() {
		return (EReference)dependencyPropagationRelationshipEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getDependencyPropagationRelationship_DependentComponentInstanceReference() {
		return (EReference)dependencyPropagationRelationshipEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getComponentInstanceReference() {
		return componentInstanceReferenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getComponentInstanceReference_Assemblies() {
		return (EReference)componentInstanceReferenceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCallParameter() {
		return callParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getCallParameter_ParameterCharacterization() {
		return (EAttribute)callParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getServiceInputParameter() {
		return serviceInputParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getServiceInputParameter_ProvidingRole() {
		return (EReference)serviceInputParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getServiceInputParameter_Parameter() {
		return (EReference)serviceInputParameterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getServiceOutputParameter() {
		return serviceOutputParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getServiceOutputParameter_ProvidingRole() {
		return (EReference)serviceOutputParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getServiceOutputParameter_Parameter() {
		return (EReference)serviceOutputParameterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getExternalCallReturnParameter() {
		return externalCallReturnParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getExternalCallReturnParameter_ExternalCall() {
		return (EReference)externalCallReturnParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getExternalCallReturnParameter_Parameter() {
		return (EReference)externalCallReturnParameterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getExternalCallParameter() {
		return externalCallParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getExternalCallParameter_ExternalCall() {
		return (EReference)externalCallParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getExternalCallParameter_Parameter() {
		return (EReference)externalCallParameterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getInfluencableModelVariable() {
		return influencableModelVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getInfluencableModelVariable_Name() {
		return (EAttribute)influencableModelVariableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getModelVariableCharacterizationType() {
		return modelVariableCharacterizationTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getRelationshipCharacterizationType() {
		return relationshipCharacterizationTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getParameterCharacterizationType() {
		return parameterCharacterizationTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ParameterdependenciesFactory getParameterdependenciesFactory() {
		return (ParameterdependenciesFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		modelVariableEClass = createEClass(MODEL_VARIABLE);
		createEReference(modelVariableEClass, MODEL_VARIABLE__SCOPE_SET);

		scopeSetEClass = createEClass(SCOPE_SET);
		createEReference(scopeSetEClass, SCOPE_SET__SCOPE);

		scopeEClass = createEClass(SCOPE);
		createEReference(scopeEClass, SCOPE__SCOPE);

		controlFlowVariableEClass = createEClass(CONTROL_FLOW_VARIABLE);

		shadowParameterEClass = createEClass(SHADOW_PARAMETER);
		createEAttribute(shadowParameterEClass, SHADOW_PARAMETER__NAME);
		createEAttribute(shadowParameterEClass, SHADOW_PARAMETER__DESCRIPTION);

		relationshipEClass = createEClass(RELATIONSHIP);
		createEReference(relationshipEClass, RELATIONSHIP__EMPIRICAL_DESCRIPTION);
		createEReference(relationshipEClass, RELATIONSHIP__EXPLICIT_DESCRIPTION);
		createEAttribute(relationshipEClass, RELATIONSHIP__CHARACTERIZATION);
		createEReference(relationshipEClass, RELATIONSHIP__DEPENDENT);
		createEReference(relationshipEClass, RELATIONSHIP__INDEPENDENT);

		dependencyRelationshipEClass = createEClass(DEPENDENCY_RELATIONSHIP);

		dependencyPropagationRelationshipEClass = createEClass(DEPENDENCY_PROPAGATION_RELATIONSHIP);
		createEReference(dependencyPropagationRelationshipEClass, DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES);
		createEReference(dependencyPropagationRelationshipEClass, DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE);

		componentInstanceReferenceEClass = createEClass(COMPONENT_INSTANCE_REFERENCE);
		createEReference(componentInstanceReferenceEClass, COMPONENT_INSTANCE_REFERENCE__ASSEMBLIES);

		callParameterEClass = createEClass(CALL_PARAMETER);
		createEAttribute(callParameterEClass, CALL_PARAMETER__PARAMETER_CHARACTERIZATION);

		serviceInputParameterEClass = createEClass(SERVICE_INPUT_PARAMETER);
		createEReference(serviceInputParameterEClass, SERVICE_INPUT_PARAMETER__PROVIDING_ROLE);
		createEReference(serviceInputParameterEClass, SERVICE_INPUT_PARAMETER__PARAMETER);

		serviceOutputParameterEClass = createEClass(SERVICE_OUTPUT_PARAMETER);
		createEReference(serviceOutputParameterEClass, SERVICE_OUTPUT_PARAMETER__PROVIDING_ROLE);
		createEReference(serviceOutputParameterEClass, SERVICE_OUTPUT_PARAMETER__PARAMETER);

		externalCallReturnParameterEClass = createEClass(EXTERNAL_CALL_RETURN_PARAMETER);
		createEReference(externalCallReturnParameterEClass, EXTERNAL_CALL_RETURN_PARAMETER__EXTERNAL_CALL);
		createEReference(externalCallReturnParameterEClass, EXTERNAL_CALL_RETURN_PARAMETER__PARAMETER);

		externalCallParameterEClass = createEClass(EXTERNAL_CALL_PARAMETER);
		createEReference(externalCallParameterEClass, EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL);
		createEReference(externalCallParameterEClass, EXTERNAL_CALL_PARAMETER__PARAMETER);

		influencableModelVariableEClass = createEClass(INFLUENCABLE_MODEL_VARIABLE);
		createEAttribute(influencableModelVariableEClass, INFLUENCABLE_MODEL_VARIABLE__NAME);

		// Create enums
		modelVariableCharacterizationTypeEEnum = createEEnum(MODEL_VARIABLE_CHARACTERIZATION_TYPE);
		relationshipCharacterizationTypeEEnum = createEEnum(RELATIONSHIP_CHARACTERIZATION_TYPE);
		parameterCharacterizationTypeEEnum = createEEnum(PARAMETER_CHARACTERIZATION_TYPE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		IdentifierPackage theIdentifierPackage = (IdentifierPackage)EPackage.Registry.INSTANCE.getEPackage(IdentifierPackage.eNS_URI);
		RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);
		ServicebehaviorPackage theServicebehaviorPackage = (ServicebehaviorPackage)EPackage.Registry.INSTANCE.getEPackage(ServicebehaviorPackage.eNS_URI);
		FunctionsPackage theFunctionsPackage = (FunctionsPackage)EPackage.Registry.INSTANCE.getEPackage(FunctionsPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		modelVariableEClass.getESuperTypes().add(theIdentifierPackage.getIdentifier());
		controlFlowVariableEClass.getESuperTypes().add(theServicebehaviorPackage.getRelationshipVariable());
		shadowParameterEClass.getESuperTypes().add(theServicebehaviorPackage.getRelationshipVariable());
		dependencyRelationshipEClass.getESuperTypes().add(this.getRelationship());
		dependencyPropagationRelationshipEClass.getESuperTypes().add(this.getRelationship());
		callParameterEClass.getESuperTypes().add(theServicebehaviorPackage.getRelationshipVariable());
		serviceInputParameterEClass.getESuperTypes().add(this.getCallParameter());
		serviceOutputParameterEClass.getESuperTypes().add(this.getCallParameter());
		externalCallReturnParameterEClass.getESuperTypes().add(this.getCallParameter());
		externalCallParameterEClass.getESuperTypes().add(this.getCallParameter());
		influencableModelVariableEClass.getESuperTypes().add(this.getModelVariable());

		// Initialize classes and features; add operations and parameters
		initEClass(modelVariableEClass, ModelVariable.class, "ModelVariable", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelVariable_ScopeSet(), this.getScopeSet(), null, "scopeSet", null, 0, 1, ModelVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(scopeSetEClass, ScopeSet.class, "ScopeSet", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getScopeSet_Scope(), this.getScope(), null, "scope", null, 0, -1, ScopeSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(scopeEClass, Scope.class, "Scope", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getScope_Scope(), theRepositoryPackage.getInterfaceProvidingRequiringEntity(), null, "scope", null, 1, 1, Scope.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(controlFlowVariableEClass, ControlFlowVariable.class, "ControlFlowVariable", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(shadowParameterEClass, ShadowParameter.class, "ShadowParameter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getShadowParameter_Name(), ecorePackage.getEString(), "name", null, 1, 1, ShadowParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getShadowParameter_Description(), ecorePackage.getEString(), "description", null, 1, 1, ShadowParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(relationshipEClass, Relationship.class, "Relationship", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRelationship_EmpiricalDescription(), theFunctionsPackage.getEmpiricalDescription(), null, "empiricalDescription", null, 0, 1, Relationship.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRelationship_ExplicitDescription(), theFunctionsPackage.getExplicitDescription(), null, "explicitDescription", null, 0, 1, Relationship.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRelationship_Characterization(), this.getRelationshipCharacterizationType(), "characterization", null, 1, 1, Relationship.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRelationship_Dependent(), theServicebehaviorPackage.getRelationshipVariable(), null, "dependent", null, 1, 1, Relationship.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRelationship_Independent(), theServicebehaviorPackage.getRelationshipVariable(), null, "independent", null, 1, -1, Relationship.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dependencyRelationshipEClass, DependencyRelationship.class, "DependencyRelationship", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dependencyPropagationRelationshipEClass, DependencyPropagationRelationship.class, "DependencyPropagationRelationship", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDependencyPropagationRelationship_IndependentComponentInstanceReferences(), this.getComponentInstanceReference(), null, "independentComponentInstanceReferences", null, 1, -1, DependencyPropagationRelationship.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDependencyPropagationRelationship_DependentComponentInstanceReference(), this.getComponentInstanceReference(), null, "dependentComponentInstanceReference", null, 1, 1, DependencyPropagationRelationship.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(componentInstanceReferenceEClass, ComponentInstanceReference.class, "ComponentInstanceReference", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getComponentInstanceReference_Assemblies(), theRepositoryPackage.getAssemblyContext(), null, "assemblies", null, 0, -1, ComponentInstanceReference.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(callParameterEClass, CallParameter.class, "CallParameter", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCallParameter_ParameterCharacterization(), this.getParameterCharacterizationType(), "parameterCharacterization", null, 1, 1, CallParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(serviceInputParameterEClass, ServiceInputParameter.class, "ServiceInputParameter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceInputParameter_ProvidingRole(), theRepositoryPackage.getInterfaceProvidingRole(), null, "providingRole", null, 1, 1, ServiceInputParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getServiceInputParameter_Parameter(), theRepositoryPackage.getInputParameter(), null, "parameter", null, 1, 1, ServiceInputParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(serviceOutputParameterEClass, ServiceOutputParameter.class, "ServiceOutputParameter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceOutputParameter_ProvidingRole(), theRepositoryPackage.getInterfaceProvidingRole(), null, "providingRole", null, 1, 1, ServiceOutputParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getServiceOutputParameter_Parameter(), theRepositoryPackage.getOutputParameter(), null, "parameter", null, 1, 1, ServiceOutputParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(externalCallReturnParameterEClass, ExternalCallReturnParameter.class, "ExternalCallReturnParameter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExternalCallReturnParameter_ExternalCall(), theServicebehaviorPackage.getExternalCall(), null, "externalCall", null, 1, 1, ExternalCallReturnParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getExternalCallReturnParameter_Parameter(), theRepositoryPackage.getOutputParameter(), null, "parameter", null, 0, 1, ExternalCallReturnParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(externalCallParameterEClass, ExternalCallParameter.class, "ExternalCallParameter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExternalCallParameter_ExternalCall(), theServicebehaviorPackage.getExternalCall(), null, "externalCall", null, 1, 1, ExternalCallParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getExternalCallParameter_Parameter(), theRepositoryPackage.getInputParameter(), null, "parameter", null, 1, 1, ExternalCallParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(influencableModelVariableEClass, InfluencableModelVariable.class, "InfluencableModelVariable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getInfluencableModelVariable_Name(), ecorePackage.getEString(), "name", null, 0, 1, InfluencableModelVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(modelVariableCharacterizationTypeEEnum, ModelVariableCharacterizationType.class, "ModelVariableCharacterizationType");
		addEEnumLiteral(modelVariableCharacterizationTypeEEnum, ModelVariableCharacterizationType.EMPIRICAL);
		addEEnumLiteral(modelVariableCharacterizationTypeEEnum, ModelVariableCharacterizationType.EXPLICIT);

		initEEnum(relationshipCharacterizationTypeEEnum, RelationshipCharacterizationType.class, "RelationshipCharacterizationType");
		addEEnumLiteral(relationshipCharacterizationTypeEEnum, RelationshipCharacterizationType.EMPIRICAL);
		addEEnumLiteral(relationshipCharacterizationTypeEEnum, RelationshipCharacterizationType.EXPLICIT);
		addEEnumLiteral(relationshipCharacterizationTypeEEnum, RelationshipCharacterizationType.IDENTITY);

		initEEnum(parameterCharacterizationTypeEEnum, ParameterCharacterizationType.class, "ParameterCharacterizationType");
		addEEnumLiteral(parameterCharacterizationTypeEEnum, ParameterCharacterizationType.VALUE);
		addEEnumLiteral(parameterCharacterizationTypeEEnum, ParameterCharacterizationType.NUMBER_OF_ELEMENTS);
		addEEnumLiteral(parameterCharacterizationTypeEEnum, ParameterCharacterizationType.BYTE_SIZE);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/OCL/Import
		createImportAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
		createPivotAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/OCL/Import</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createImportAnnotations() {
		String source = "http://www.eclipse.org/OCL/Import";
		addAnnotation
		  (this,
		   source,
		   new String[] {
			   "core_0", "../../tools.descartes.dml.core/model/core.ecore#/",
			   "ecore_0", "http://www.eclipse.org/emf/2002/Ecore",
			   "functions_0", "functions.ecore#/",
			   "identifier", "../../tools.descartes.dml.identifier/model/identifier.ecore#/",
			   "repository_0", "repository.ecore#/",
			   "servicebehavior_0", "servicebehavior.ecore#/"
		   });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";
		addAnnotation
		  (this,
		   source,
		   new String[] {
			   "invocationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			   "settingDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			   "validationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"
		   });
		addAnnotation
		  (controlFlowVariableEClass,
		   source,
		   new String[] {
			   "constraints", "EnforceExplicitDescriptionWhenExplicitCharacterizationType"
		   });
		addAnnotation
		  (relationshipEClass,
		   source,
		   new String[] {
			   "constraints", "EnforceExplicitDescriptionWhenExplicitCharacterizationType EnforceEmpiricalDescriptionWhenEmpiricalCharacterizationType"
		   });
		addAnnotation
		  (dependencyRelationshipEClass,
		   source,
		   new String[] {
			   "constraints", "DelegationOnlyAllowedWithSingleSource"
		   });
		addAnnotation
		  (dependencyPropagationRelationshipEClass,
		   source,
		   new String[] {
			   "constraints", "NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences DelegationOnlyAllowedWithSingleSource"
		   });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createPivotAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";
		addAnnotation
		  (controlFlowVariableEClass,
		   source,
		   new String[] {
			   "EnforceExplicitDescriptionWhenExplicitCharacterizationType", "\n\t\t\tself.characterization = RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null"
		   });
		addAnnotation
		  (relationshipEClass,
		   source,
		   new String[] {
			   "EnforceExplicitDescriptionWhenExplicitCharacterizationType", "\n\t\t\tself.characterization = RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null",
			   "EnforceEmpiricalDescriptionWhenEmpiricalCharacterizationType", "\n\t\t\tself.characterization = RelationshipCharacterizationType::EMPIRICAL implies empiricalDescription <> null"
		   });
		addAnnotation
		  (dependencyRelationshipEClass,
		   source,
		   new String[] {
			   "DelegationOnlyAllowedWithSingleSource", "\n\t\t\tself.characterization = RelationshipCharacterizationType::IDENTITY implies independent->size() = 1"
		   });
		addAnnotation
		  (dependencyPropagationRelationshipEClass,
		   source,
		   new String[] {
			   "NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences", "\n\t\t\tindependent->size() = independentComponentInstanceReferences->size()",
			   "DelegationOnlyAllowedWithSingleSource", "\n\t\t\tself.characterization = RelationshipCharacterizationType::IDENTITY implies independent->size() = 1"
		   });
	}

} //ParameterdependenciesPackageImpl
