/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.internal.cdo.CDOObjectImpl;

import tools.descartes.dml.mm.applicationlevel.functions.EmpiricalDescription;
import tools.descartes.dml.mm.applicationlevel.functions.ExplicitDescription;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.Relationship;
import tools.descartes.dml.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.RelationshipVariable;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Relationship</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getEmpiricalDescription <em>Empirical Description</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getExplicitDescription <em>Explicit Description</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getDependent <em>Dependent</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getIndependent <em>Independent</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class RelationshipImpl extends CDOObjectImpl implements Relationship {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RelationshipImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.RELATIONSHIP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected int eStaticFeatureCount() {
		return 0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EmpiricalDescription getEmpiricalDescription() {
		return (EmpiricalDescription)eGet(ParameterdependenciesPackage.Literals.RELATIONSHIP__EMPIRICAL_DESCRIPTION, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEmpiricalDescription(EmpiricalDescription newEmpiricalDescription) {
		eSet(ParameterdependenciesPackage.Literals.RELATIONSHIP__EMPIRICAL_DESCRIPTION, newEmpiricalDescription);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExplicitDescription getExplicitDescription() {
		return (ExplicitDescription)eGet(ParameterdependenciesPackage.Literals.RELATIONSHIP__EXPLICIT_DESCRIPTION, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setExplicitDescription(ExplicitDescription newExplicitDescription) {
		eSet(ParameterdependenciesPackage.Literals.RELATIONSHIP__EXPLICIT_DESCRIPTION, newExplicitDescription);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public RelationshipCharacterizationType getCharacterization() {
		return (RelationshipCharacterizationType)eGet(ParameterdependenciesPackage.Literals.RELATIONSHIP__CHARACTERIZATION, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCharacterization(RelationshipCharacterizationType newCharacterization) {
		eSet(ParameterdependenciesPackage.Literals.RELATIONSHIP__CHARACTERIZATION, newCharacterization);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public RelationshipVariable getDependent() {
		return (RelationshipVariable)eGet(ParameterdependenciesPackage.Literals.RELATIONSHIP__DEPENDENT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDependent(RelationshipVariable newDependent) {
		eSet(ParameterdependenciesPackage.Literals.RELATIONSHIP__DEPENDENT, newDependent);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public EList<RelationshipVariable> getIndependent() {
		return (EList<RelationshipVariable>)eGet(ParameterdependenciesPackage.Literals.RELATIONSHIP__INDEPENDENT, true);
	}

} //RelationshipImpl
