/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.repository;

import org.eclipse.emf.common.util.EList;

import tools.descartes.dml.mm.applicationlevel.servicebehavior.FineGrainedBehavior;
import tools.descartes.dml.mm.applicationlevel.system.StatisticalModel;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Basic Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.repository.BasicComponent#getSemaphores <em>Semaphores</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.repository.BasicComponent#getFineGrainedBehavior <em>Fine Grained Behavior</em>}</li>
 *   <li>{@link tools.descartes.dml.mm.applicationlevel.repository.BasicComponent#getStatisticalModel <em>Statistical Model</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dml.mm.applicationlevel.repository.RepositoryPackage#getBasicComponent()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AtMostOneFineGrainedBehaviorPerProvidedService ReferencedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot AtMostOneFineGrainedBehaviorPerProvidedService='\n\t\t\tnot self.fineGrainedBehavior-&gt;isEmpty() implies \n\t\t\tself.fineGrainedBehavior-&gt;isUnique(fgb1 | fgb1.describedSignature)' ReferencedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole='\n\t\t\tself.fineGrainedBehavior-&gt;forAll(fgb1 | self.interfaceProvidingRoles-&gt;exists(p | p.interface = fgb1.describedSignature.interface))'"
 * @generated
 */
public interface BasicComponent extends RepositoryComponent {
	/**
	 * Returns the value of the '<em><b>Semaphores</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dml.mm.applicationlevel.repository.Semaphore}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Semaphores</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Semaphores</em>' containment reference list.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RepositoryPackage#getBasicComponent_Semaphores()
	 * @model containment="true" resolveProxies="true" ordered="false"
	 * @generated
	 */
	EList<Semaphore> getSemaphores();

	/**
	 * Returns the value of the '<em><b>Fine Grained Behavior</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.FineGrainedBehavior}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Fine Grained Behavior</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Fine Grained Behavior</em>' containment reference list.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RepositoryPackage#getBasicComponent_FineGrainedBehavior()
	 * @model containment="true" resolveProxies="true"
	 * @generated
	 */
	EList<FineGrainedBehavior> getFineGrainedBehavior();

	/**
	 * Returns the value of the '<em><b>Statistical Model</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dml.mm.applicationlevel.system.StatisticalModel}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Statistical Model</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Statistical Model</em>' containment reference list.
	 * @see tools.descartes.dml.mm.applicationlevel.repository.RepositoryPackage#getBasicComponent_StatisticalModel()
	 * @model containment="true" resolveProxies="true"
	 * @generated
	 */
	EList<StatisticalModel> getStatisticalModel();

} // BasicComponent
