/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.servicebehavior.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.*;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.AcquireAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.BlackBoxBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchProbabilities;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.CallFrequency;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCall;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallFrequency;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.FineGrainedBehavior;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ForkAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.InternalAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopIterationCount;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ReleaseAction;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ResourceDemand;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ResponseTime;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ServicebehaviorFactory;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ServicebehaviorFactoryImpl extends EFactoryImpl implements ServicebehaviorFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ServicebehaviorFactory init() {
		try {
			ServicebehaviorFactory theServicebehaviorFactory = (ServicebehaviorFactory)EPackage.Registry.INSTANCE.getEFactory(ServicebehaviorPackage.eNS_URI);
			if (theServicebehaviorFactory != null) {
				return theServicebehaviorFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new ServicebehaviorFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServicebehaviorFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR: return createFineGrainedBehavior();
			case ServicebehaviorPackage.COMPONENT_INTERNAL_BEHAVIOR: return createComponentInternalBehavior();
			case ServicebehaviorPackage.ACQUIRE_ACTION: return createAcquireAction();
			case ServicebehaviorPackage.RELEASE_ACTION: return createReleaseAction();
			case ServicebehaviorPackage.INTERNAL_ACTION: return createInternalAction();
			case ServicebehaviorPackage.FORK_ACTION: return createForkAction();
			case ServicebehaviorPackage.BRANCH_ACTION: return createBranchAction();
			case ServicebehaviorPackage.BRANCH_PROBABILITIES: return createBranchProbabilities();
			case ServicebehaviorPackage.LOOP_ACTION: return createLoopAction();
			case ServicebehaviorPackage.LOOP_ITERATION_COUNT: return createLoopIterationCount();
			case ServicebehaviorPackage.EXTERNAL_CALL_ACTION: return createExternalCallAction();
			case ServicebehaviorPackage.EXTERNAL_CALL: return createExternalCall();
			case ServicebehaviorPackage.RESOURCE_DEMAND: return createResourceDemand();
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR: return createCoarseGrainedBehavior();
			case ServicebehaviorPackage.EXTERNAL_CALL_FREQUENCY: return createExternalCallFrequency();
			case ServicebehaviorPackage.CALL_FREQUENCY: return createCallFrequency();
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR: return createBlackBoxBehavior();
			case ServicebehaviorPackage.RESPONSE_TIME: return createResponseTime();
			case ServicebehaviorPackage.RELATIONSHIP_VARIABLE: return createRelationshipVariable();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public FineGrainedBehavior createFineGrainedBehavior() {
		FineGrainedBehaviorImpl fineGrainedBehavior = new FineGrainedBehaviorImpl();
		return fineGrainedBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComponentInternalBehavior createComponentInternalBehavior() {
		ComponentInternalBehaviorImpl componentInternalBehavior = new ComponentInternalBehaviorImpl();
		return componentInternalBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AcquireAction createAcquireAction() {
		AcquireActionImpl acquireAction = new AcquireActionImpl();
		return acquireAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ReleaseAction createReleaseAction() {
		ReleaseActionImpl releaseAction = new ReleaseActionImpl();
		return releaseAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public InternalAction createInternalAction() {
		InternalActionImpl internalAction = new InternalActionImpl();
		return internalAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ForkAction createForkAction() {
		ForkActionImpl forkAction = new ForkActionImpl();
		return forkAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BranchAction createBranchAction() {
		BranchActionImpl branchAction = new BranchActionImpl();
		return branchAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BranchProbabilities createBranchProbabilities() {
		BranchProbabilitiesImpl branchProbabilities = new BranchProbabilitiesImpl();
		return branchProbabilities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LoopAction createLoopAction() {
		LoopActionImpl loopAction = new LoopActionImpl();
		return loopAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LoopIterationCount createLoopIterationCount() {
		LoopIterationCountImpl loopIterationCount = new LoopIterationCountImpl();
		return loopIterationCount;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExternalCallAction createExternalCallAction() {
		ExternalCallActionImpl externalCallAction = new ExternalCallActionImpl();
		return externalCallAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExternalCall createExternalCall() {
		ExternalCallImpl externalCall = new ExternalCallImpl();
		return externalCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceDemand createResourceDemand() {
		ResourceDemandImpl resourceDemand = new ResourceDemandImpl();
		return resourceDemand;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public CoarseGrainedBehavior createCoarseGrainedBehavior() {
		CoarseGrainedBehaviorImpl coarseGrainedBehavior = new CoarseGrainedBehaviorImpl();
		return coarseGrainedBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExternalCallFrequency createExternalCallFrequency() {
		ExternalCallFrequencyImpl externalCallFrequency = new ExternalCallFrequencyImpl();
		return externalCallFrequency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public CallFrequency createCallFrequency() {
		CallFrequencyImpl callFrequency = new CallFrequencyImpl();
		return callFrequency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BlackBoxBehavior createBlackBoxBehavior() {
		BlackBoxBehaviorImpl blackBoxBehavior = new BlackBoxBehaviorImpl();
		return blackBoxBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResponseTime createResponseTime() {
		ResponseTimeImpl responseTime = new ResponseTimeImpl();
		return responseTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public RelationshipVariable createRelationshipVariable() {
		RelationshipVariableImpl relationshipVariable = new RelationshipVariableImpl();
		return relationshipVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ServicebehaviorPackage getServicebehaviorPackage() {
		return (ServicebehaviorPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static ServicebehaviorPackage getPackage() {
		return ServicebehaviorPackage.eINSTANCE;
	}

} //ServicebehaviorFactoryImpl
