/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.servicebehavior.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import tools.descartes.dml.mm.applicationlevel.servicebehavior.util.ServicebehaviorAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ServicebehaviorItemProviderAdapterFactory extends ServicebehaviorAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServicebehaviorItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.FineGrainedBehavior} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FineGrainedBehaviorItemProvider fineGrainedBehaviorItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.FineGrainedBehavior}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFineGrainedBehaviorAdapter() {
		if (fineGrainedBehaviorItemProvider == null) {
			fineGrainedBehaviorItemProvider = new FineGrainedBehaviorItemProvider(this);
		}

		return fineGrainedBehaviorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ComponentInternalBehavior} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComponentInternalBehaviorItemProvider componentInternalBehaviorItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ComponentInternalBehavior}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createComponentInternalBehaviorAdapter() {
		if (componentInternalBehaviorItemProvider == null) {
			componentInternalBehaviorItemProvider = new ComponentInternalBehaviorItemProvider(this);
		}

		return componentInternalBehaviorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.AcquireAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AcquireActionItemProvider acquireActionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.AcquireAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAcquireActionAdapter() {
		if (acquireActionItemProvider == null) {
			acquireActionItemProvider = new AcquireActionItemProvider(this);
		}

		return acquireActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ReleaseAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReleaseActionItemProvider releaseActionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ReleaseAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReleaseActionAdapter() {
		if (releaseActionItemProvider == null) {
			releaseActionItemProvider = new ReleaseActionItemProvider(this);
		}

		return releaseActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.InternalAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InternalActionItemProvider internalActionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.InternalAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInternalActionAdapter() {
		if (internalActionItemProvider == null) {
			internalActionItemProvider = new InternalActionItemProvider(this);
		}

		return internalActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ForkAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ForkActionItemProvider forkActionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ForkAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createForkActionAdapter() {
		if (forkActionItemProvider == null) {
			forkActionItemProvider = new ForkActionItemProvider(this);
		}

		return forkActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BranchActionItemProvider branchActionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBranchActionAdapter() {
		if (branchActionItemProvider == null) {
			branchActionItemProvider = new BranchActionItemProvider(this);
		}

		return branchActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchProbabilities} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BranchProbabilitiesItemProvider branchProbabilitiesItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.BranchProbabilities}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBranchProbabilitiesAdapter() {
		if (branchProbabilitiesItemProvider == null) {
			branchProbabilitiesItemProvider = new BranchProbabilitiesItemProvider(this);
		}

		return branchProbabilitiesItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoopActionItemProvider loopActionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLoopActionAdapter() {
		if (loopActionItemProvider == null) {
			loopActionItemProvider = new LoopActionItemProvider(this);
		}

		return loopActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopIterationCount} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoopIterationCountItemProvider loopIterationCountItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.LoopIterationCount}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLoopIterationCountAdapter() {
		if (loopIterationCountItemProvider == null) {
			loopIterationCountItemProvider = new LoopIterationCountItemProvider(this);
		}

		return loopIterationCountItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalCallActionItemProvider externalCallActionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExternalCallActionAdapter() {
		if (externalCallActionItemProvider == null) {
			externalCallActionItemProvider = new ExternalCallActionItemProvider(this);
		}

		return externalCallActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCall} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalCallItemProvider externalCallItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCall}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExternalCallAdapter() {
		if (externalCallItemProvider == null) {
			externalCallItemProvider = new ExternalCallItemProvider(this);
		}

		return externalCallItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ResourceDemand} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResourceDemandItemProvider resourceDemandItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ResourceDemand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createResourceDemandAdapter() {
		if (resourceDemandItemProvider == null) {
			resourceDemandItemProvider = new ResourceDemandItemProvider(this);
		}

		return resourceDemandItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoarseGrainedBehaviorItemProvider coarseGrainedBehaviorItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCoarseGrainedBehaviorAdapter() {
		if (coarseGrainedBehaviorItemProvider == null) {
			coarseGrainedBehaviorItemProvider = new CoarseGrainedBehaviorItemProvider(this);
		}

		return coarseGrainedBehaviorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallFrequency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalCallFrequencyItemProvider externalCallFrequencyItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ExternalCallFrequency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExternalCallFrequencyAdapter() {
		if (externalCallFrequencyItemProvider == null) {
			externalCallFrequencyItemProvider = new ExternalCallFrequencyItemProvider(this);
		}

		return externalCallFrequencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.CallFrequency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallFrequencyItemProvider callFrequencyItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.CallFrequency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallFrequencyAdapter() {
		if (callFrequencyItemProvider == null) {
			callFrequencyItemProvider = new CallFrequencyItemProvider(this);
		}

		return callFrequencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.BlackBoxBehavior} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BlackBoxBehaviorItemProvider blackBoxBehaviorItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.BlackBoxBehavior}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBlackBoxBehaviorAdapter() {
		if (blackBoxBehaviorItemProvider == null) {
			blackBoxBehaviorItemProvider = new BlackBoxBehaviorItemProvider(this);
		}

		return blackBoxBehaviorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ResponseTime} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResponseTimeItemProvider responseTimeItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.ResponseTime}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createResponseTimeAdapter() {
		if (responseTimeItemProvider == null) {
			responseTimeItemProvider = new ResponseTimeItemProvider(this);
		}

		return responseTimeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.RelationshipVariable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RelationshipVariableItemProvider relationshipVariableItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dml.mm.applicationlevel.servicebehavior.RelationshipVariable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRelationshipVariableAdapter() {
		if (relationshipVariableItemProvider == null) {
			relationshipVariableItemProvider = new RelationshipVariableItemProvider(this);
		}

		return relationshipVariableItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void dispose() {
		if (fineGrainedBehaviorItemProvider != null) fineGrainedBehaviorItemProvider.dispose();
		if (componentInternalBehaviorItemProvider != null) componentInternalBehaviorItemProvider.dispose();
		if (acquireActionItemProvider != null) acquireActionItemProvider.dispose();
		if (releaseActionItemProvider != null) releaseActionItemProvider.dispose();
		if (internalActionItemProvider != null) internalActionItemProvider.dispose();
		if (forkActionItemProvider != null) forkActionItemProvider.dispose();
		if (branchActionItemProvider != null) branchActionItemProvider.dispose();
		if (branchProbabilitiesItemProvider != null) branchProbabilitiesItemProvider.dispose();
		if (loopActionItemProvider != null) loopActionItemProvider.dispose();
		if (loopIterationCountItemProvider != null) loopIterationCountItemProvider.dispose();
		if (externalCallActionItemProvider != null) externalCallActionItemProvider.dispose();
		if (externalCallItemProvider != null) externalCallItemProvider.dispose();
		if (resourceDemandItemProvider != null) resourceDemandItemProvider.dispose();
		if (coarseGrainedBehaviorItemProvider != null) coarseGrainedBehaviorItemProvider.dispose();
		if (externalCallFrequencyItemProvider != null) externalCallFrequencyItemProvider.dispose();
		if (callFrequencyItemProvider != null) callFrequencyItemProvider.dispose();
		if (blackBoxBehaviorItemProvider != null) blackBoxBehaviorItemProvider.dispose();
		if (responseTimeItemProvider != null) responseTimeItemProvider.dispose();
		if (relationshipVariableItemProvider != null) relationshipVariableItemProvider.dispose();
	}

}
