/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.system;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.EReference;
import tools.descartes.dml.mm.applicationlevel.repository.RepositoryPackage;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dml.mm.applicationlevel.system.SystemFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface SystemPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "system";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes.tools/metamodel/system/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "system";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SystemPackage eINSTANCE = tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.SystemImpl <em>System</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getSystem()
	 * @generated
	 */
	int SYSTEM = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__ID = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__NAME = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Assembly Contexts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__ASSEMBLY_CONTEXTS = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__ASSEMBLY_CONTEXTS;

	/**
	 * The feature id for the '<em><b>Assembly Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__ASSEMBLY_CONNECTORS = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__ASSEMBLY_CONNECTORS;

	/**
	 * The feature id for the '<em><b>Providing Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__PROVIDING_DELEGATION_CONNECTORS = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__PROVIDING_DELEGATION_CONNECTORS;

	/**
	 * The feature id for the '<em><b>Requiring Delegation Connectors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__REQUIRING_DELEGATION_CONNECTORS = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__REQUIRING_DELEGATION_CONNECTORS;

	/**
	 * The feature id for the '<em><b>Interface Providing Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__INTERFACE_PROVIDING_ROLES = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__INTERFACE_PROVIDING_ROLES;

	/**
	 * The feature id for the '<em><b>Black Box Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__BLACK_BOX_BEHAVIOR = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__BLACK_BOX_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Interface Requiring Roles</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__INTERFACE_REQUIRING_ROLES = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__INTERFACE_REQUIRING_ROLES;

	/**
	 * The feature id for the '<em><b>Coarse Grained Behavior</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__COARSE_GRAINED_BEHAVIOR = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__COARSE_GRAINED_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__RELATIONSHIPS = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY__RELATIONSHIPS;

	/**
	 * The number of structural features of the '<em>System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_FEATURE_COUNT = RepositoryPackage.COMPOSED_PROVIDING_REQUIRING_ENTITY_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.StatisticalModel <em>Statistical Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.StatisticalModel
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getStatisticalModel()
	 * @generated
	 */
	int STATISTICAL_MODEL = 1;

	/**
	 * The feature id for the '<em><b>Described Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATISTICAL_MODEL__DESCRIBED_SIGNATURE = ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE;

	/**
	 * The feature id for the '<em><b>Call Parameter</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATISTICAL_MODEL__CALL_PARAMETER = ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__CALL_PARAMETER;

	/**
	 * The feature id for the '<em><b>Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATISTICAL_MODEL__INTERFACE_PROVIDING_ROLE = ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE;

	/**
	 * The number of structural features of the '<em>Statistical Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATISTICAL_MODEL_FEATURE_COUNT = ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.MARSModelImpl <em>MARS Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.MARSModelImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getMARSModel()
	 * @generated
	 */
	int MARS_MODEL = 2;

	/**
	 * The feature id for the '<em><b>Described Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MARS_MODEL__DESCRIBED_SIGNATURE = STATISTICAL_MODEL__DESCRIBED_SIGNATURE;

	/**
	 * The feature id for the '<em><b>Call Parameter</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MARS_MODEL__CALL_PARAMETER = STATISTICAL_MODEL__CALL_PARAMETER;

	/**
	 * The feature id for the '<em><b>Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MARS_MODEL__INTERFACE_PROVIDING_ROLE = STATISTICAL_MODEL__INTERFACE_PROVIDING_ROLE;

	/**
	 * The feature id for the '<em><b>Basis Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MARS_MODEL__BASIS_FUNCTIONS = STATISTICAL_MODEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MARS Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MARS_MODEL_FEATURE_COUNT = STATISTICAL_MODEL_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.BasisFunctionImpl <em>Basis Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.BasisFunctionImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getBasisFunction()
	 * @generated
	 */
	int BASIS_FUNCTION = 3;

	/**
	 * The feature id for the '<em><b>Coefficient</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIS_FUNCTION__COEFFICIENT = 0;

	/**
	 * The number of structural features of the '<em>Basis Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIS_FUNCTION_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.ConstantImpl <em>Constant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.ConstantImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getConstant()
	 * @generated
	 */
	int CONSTANT = 4;

	/**
	 * The feature id for the '<em><b>Coefficient</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT__COEFFICIENT = BASIS_FUNCTION__COEFFICIENT;

	/**
	 * The number of structural features of the '<em>Constant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_FEATURE_COUNT = BASIS_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.HingeImpl <em>Hinge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.HingeImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getHinge()
	 * @generated
	 */
	int HINGE = 5;

	/**
	 * The feature id for the '<em><b>Coefficient</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE__COEFFICIENT = BASIS_FUNCTION__COEFFICIENT;

	/**
	 * The feature id for the '<em><b>Knot</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE__KNOT = BASIS_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Side</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE__SIDE = BASIS_FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Variable Reference</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE__VARIABLE_REFERENCE = BASIS_FUNCTION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Hinge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE_FEATURE_COUNT = BASIS_FUNCTION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.HingeProductImpl <em>Hinge Product</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.HingeProductImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getHingeProduct()
	 * @generated
	 */
	int HINGE_PRODUCT = 6;

	/**
	 * The feature id for the '<em><b>Coefficient</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE_PRODUCT__COEFFICIENT = BASIS_FUNCTION__COEFFICIENT;

	/**
	 * The feature id for the '<em><b>Hinges</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE_PRODUCT__HINGES = BASIS_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Hinge Product</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HINGE_PRODUCT_FEATURE_COUNT = BASIS_FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.VariableReference <em>Variable Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.VariableReference
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getVariableReference()
	 * @generated
	 */
	int VARIABLE_REFERENCE = 7;

	/**
	 * The number of structural features of the '<em>Variable Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_REFERENCE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.WorkloadIntensityImpl <em>Workload Intensity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.WorkloadIntensityImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getWorkloadIntensity()
	 * @generated
	 */
	int WORKLOAD_INTENSITY = 8;

	/**
	 * The feature id for the '<em><b>Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_INTENSITY__INTERFACE_PROVIDING_ROLE = VARIABLE_REFERENCE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_INTENSITY__SIGNATURE = VARIABLE_REFERENCE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Workload Intensity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_INTENSITY_FEATURE_COUNT = VARIABLE_REFERENCE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.WEKAModelImpl <em>WEKA Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.WEKAModelImpl
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getWEKAModel()
	 * @generated
	 */
	int WEKA_MODEL = 9;

	/**
	 * The feature id for the '<em><b>Described Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WEKA_MODEL__DESCRIBED_SIGNATURE = STATISTICAL_MODEL__DESCRIBED_SIGNATURE;

	/**
	 * The feature id for the '<em><b>Call Parameter</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WEKA_MODEL__CALL_PARAMETER = STATISTICAL_MODEL__CALL_PARAMETER;

	/**
	 * The feature id for the '<em><b>Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WEKA_MODEL__INTERFACE_PROVIDING_ROLE = STATISTICAL_MODEL__INTERFACE_PROVIDING_ROLE;

	/**
	 * The feature id for the '<em><b>Absolute Model Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WEKA_MODEL__ABSOLUTE_MODEL_PATH = STATISTICAL_MODEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>WEKA Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WEKA_MODEL_FEATURE_COUNT = STATISTICAL_MODEL_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dml.mm.applicationlevel.system.Side <em>Side</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dml.mm.applicationlevel.system.Side
	 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getSide()
	 * @generated
	 */
	int SIDE = 10;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.System <em>System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.System
	 * @generated
	 */
	EClass getSystem();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.StatisticalModel <em>Statistical Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Statistical Model</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.StatisticalModel
	 * @generated
	 */
	EClass getStatisticalModel();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.MARSModel <em>MARS Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MARS Model</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.MARSModel
	 * @generated
	 */
	EClass getMARSModel();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.system.MARSModel#getBasisFunctions <em>Basis Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Basis Functions</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.MARSModel#getBasisFunctions()
	 * @see #getMARSModel()
	 * @generated
	 */
	EReference getMARSModel_BasisFunctions();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.BasisFunction <em>Basis Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Basis Function</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.BasisFunction
	 * @generated
	 */
	EClass getBasisFunction();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.system.BasisFunction#getCoefficient <em>Coefficient</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Coefficient</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.BasisFunction#getCoefficient()
	 * @see #getBasisFunction()
	 * @generated
	 */
	EAttribute getBasisFunction_Coefficient();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.Constant <em>Constant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.Constant
	 * @generated
	 */
	EClass getConstant();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.Hinge <em>Hinge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hinge</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.Hinge
	 * @generated
	 */
	EClass getHinge();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.system.Hinge#getKnot <em>Knot</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Knot</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.Hinge#getKnot()
	 * @see #getHinge()
	 * @generated
	 */
	EAttribute getHinge_Knot();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.system.Hinge#getSide <em>Side</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Side</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.Hinge#getSide()
	 * @see #getHinge()
	 * @generated
	 */
	EAttribute getHinge_Side();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dml.mm.applicationlevel.system.Hinge#getVariableReference <em>Variable Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Variable Reference</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.Hinge#getVariableReference()
	 * @see #getHinge()
	 * @generated
	 */
	EReference getHinge_VariableReference();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.HingeProduct <em>Hinge Product</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hinge Product</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.HingeProduct
	 * @generated
	 */
	EClass getHingeProduct();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dml.mm.applicationlevel.system.HingeProduct#getHinges <em>Hinges</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Hinges</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.HingeProduct#getHinges()
	 * @see #getHingeProduct()
	 * @generated
	 */
	EReference getHingeProduct_Hinges();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.VariableReference <em>Variable Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Reference</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.VariableReference
	 * @generated
	 */
	EClass getVariableReference();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.WorkloadIntensity <em>Workload Intensity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Workload Intensity</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.WorkloadIntensity
	 * @generated
	 */
	EClass getWorkloadIntensity();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.system.WorkloadIntensity#getInterfaceProvidingRole <em>Interface Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interface Providing Role</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.WorkloadIntensity#getInterfaceProvidingRole()
	 * @see #getWorkloadIntensity()
	 * @generated
	 */
	EReference getWorkloadIntensity_InterfaceProvidingRole();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dml.mm.applicationlevel.system.WorkloadIntensity#getSignature <em>Signature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Signature</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.WorkloadIntensity#getSignature()
	 * @see #getWorkloadIntensity()
	 * @generated
	 */
	EReference getWorkloadIntensity_Signature();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dml.mm.applicationlevel.system.WEKAModel <em>WEKA Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>WEKA Model</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.WEKAModel
	 * @generated
	 */
	EClass getWEKAModel();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dml.mm.applicationlevel.system.WEKAModel#getAbsoluteModelPath <em>Absolute Model Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Absolute Model Path</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.WEKAModel#getAbsoluteModelPath()
	 * @see #getWEKAModel()
	 * @generated
	 */
	EAttribute getWEKAModel_AbsoluteModelPath();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dml.mm.applicationlevel.system.Side <em>Side</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Side</em>'.
	 * @see tools.descartes.dml.mm.applicationlevel.system.Side
	 * @generated
	 */
	EEnum getSide();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SystemFactory getSystemFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.SystemImpl <em>System</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getSystem()
		 * @generated
		 */
		EClass SYSTEM = eINSTANCE.getSystem();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.StatisticalModel <em>Statistical Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.StatisticalModel
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getStatisticalModel()
		 * @generated
		 */
		EClass STATISTICAL_MODEL = eINSTANCE.getStatisticalModel();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.MARSModelImpl <em>MARS Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.MARSModelImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getMARSModel()
		 * @generated
		 */
		EClass MARS_MODEL = eINSTANCE.getMARSModel();
		/**
		 * The meta object literal for the '<em><b>Basis Functions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MARS_MODEL__BASIS_FUNCTIONS = eINSTANCE.getMARSModel_BasisFunctions();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.BasisFunctionImpl <em>Basis Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.BasisFunctionImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getBasisFunction()
		 * @generated
		 */
		EClass BASIS_FUNCTION = eINSTANCE.getBasisFunction();
		/**
		 * The meta object literal for the '<em><b>Coefficient</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASIS_FUNCTION__COEFFICIENT = eINSTANCE.getBasisFunction_Coefficient();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.ConstantImpl <em>Constant</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.ConstantImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getConstant()
		 * @generated
		 */
		EClass CONSTANT = eINSTANCE.getConstant();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.HingeImpl <em>Hinge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.HingeImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getHinge()
		 * @generated
		 */
		EClass HINGE = eINSTANCE.getHinge();
		/**
		 * The meta object literal for the '<em><b>Knot</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HINGE__KNOT = eINSTANCE.getHinge_Knot();
		/**
		 * The meta object literal for the '<em><b>Side</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HINGE__SIDE = eINSTANCE.getHinge_Side();
		/**
		 * The meta object literal for the '<em><b>Variable Reference</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HINGE__VARIABLE_REFERENCE = eINSTANCE.getHinge_VariableReference();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.HingeProductImpl <em>Hinge Product</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.HingeProductImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getHingeProduct()
		 * @generated
		 */
		EClass HINGE_PRODUCT = eINSTANCE.getHingeProduct();
		/**
		 * The meta object literal for the '<em><b>Hinges</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HINGE_PRODUCT__HINGES = eINSTANCE.getHingeProduct_Hinges();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.VariableReference <em>Variable Reference</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.VariableReference
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getVariableReference()
		 * @generated
		 */
		EClass VARIABLE_REFERENCE = eINSTANCE.getVariableReference();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.WorkloadIntensityImpl <em>Workload Intensity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.WorkloadIntensityImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getWorkloadIntensity()
		 * @generated
		 */
		EClass WORKLOAD_INTENSITY = eINSTANCE.getWorkloadIntensity();
		/**
		 * The meta object literal for the '<em><b>Interface Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WORKLOAD_INTENSITY__INTERFACE_PROVIDING_ROLE = eINSTANCE.getWorkloadIntensity_InterfaceProvidingRole();
		/**
		 * The meta object literal for the '<em><b>Signature</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WORKLOAD_INTENSITY__SIGNATURE = eINSTANCE.getWorkloadIntensity_Signature();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.impl.WEKAModelImpl <em>WEKA Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.WEKAModelImpl
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getWEKAModel()
		 * @generated
		 */
		EClass WEKA_MODEL = eINSTANCE.getWEKAModel();
		/**
		 * The meta object literal for the '<em><b>Absolute Model Path</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute WEKA_MODEL__ABSOLUTE_MODEL_PATH = eINSTANCE.getWEKAModel_AbsoluteModelPath();
		/**
		 * The meta object literal for the '{@link tools.descartes.dml.mm.applicationlevel.system.Side <em>Side</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dml.mm.applicationlevel.system.Side
		 * @see tools.descartes.dml.mm.applicationlevel.system.impl.SystemPackageImpl#getSide()
		 * @generated
		 */
		EEnum SIDE = eINSTANCE.getSide();

	}

} //SystemPackage
