/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.mm.applicationlevel.system.util;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.EObjectValidator;

import tools.descartes.dml.mm.applicationlevel.repository.util.RepositoryValidator;
import tools.descartes.dml.mm.applicationlevel.servicebehavior.util.ServicebehaviorValidator;
import tools.descartes.dml.mm.applicationlevel.system.BasisFunction;
import tools.descartes.dml.mm.applicationlevel.system.Constant;
import tools.descartes.dml.mm.applicationlevel.system.Hinge;
import tools.descartes.dml.mm.applicationlevel.system.HingeProduct;
import tools.descartes.dml.mm.applicationlevel.system.MARSModel;
import tools.descartes.dml.mm.applicationlevel.system.Side;
import tools.descartes.dml.mm.applicationlevel.system.StatisticalModel;
import tools.descartes.dml.mm.applicationlevel.system.SystemPackage;
import tools.descartes.dml.mm.applicationlevel.system.VariableReference;
import tools.descartes.dml.mm.applicationlevel.system.WEKAModel;
import tools.descartes.dml.mm.applicationlevel.system.WorkloadIntensity;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see tools.descartes.dml.mm.applicationlevel.system.SystemPackage
 * @generated
 */
public class SystemValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final SystemValidator INSTANCE = new SystemValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "tools.descartes.dml.mm.applicationlevel.system";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * The cached base package validator.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RepositoryValidator repositoryValidator;

	/**
	 * The cached base package validator.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServicebehaviorValidator servicebehaviorValidator;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SystemValidator() {
		super();
		repositoryValidator = RepositoryValidator.INSTANCE;
		servicebehaviorValidator = ServicebehaviorValidator.INSTANCE;
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return SystemPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case SystemPackage.SYSTEM:
				return validateSystem((tools.descartes.dml.mm.applicationlevel.system.System)value, diagnostics, context);
			case SystemPackage.STATISTICAL_MODEL:
				return validateStatisticalModel((StatisticalModel)value, diagnostics, context);
			case SystemPackage.MARS_MODEL:
				return validateMARSModel((MARSModel)value, diagnostics, context);
			case SystemPackage.BASIS_FUNCTION:
				return validateBasisFunction((BasisFunction)value, diagnostics, context);
			case SystemPackage.CONSTANT:
				return validateConstant((Constant)value, diagnostics, context);
			case SystemPackage.HINGE:
				return validateHinge((Hinge)value, diagnostics, context);
			case SystemPackage.HINGE_PRODUCT:
				return validateHingeProduct((HingeProduct)value, diagnostics, context);
			case SystemPackage.VARIABLE_REFERENCE:
				return validateVariableReference((VariableReference)value, diagnostics, context);
			case SystemPackage.WORKLOAD_INTENSITY:
				return validateWorkloadIntensity((WorkloadIntensity)value, diagnostics, context);
			case SystemPackage.WEKA_MODEL:
				return validateWEKAModel((WEKAModel)value, diagnostics, context);
			case SystemPackage.SIDE:
				return validateSide((Side)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSystem(tools.descartes.dml.mm.applicationlevel.system.System system, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(system, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(system, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(system, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(system, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(system, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(system, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(system, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(system, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(system, diagnostics, context);
		if (result || diagnostics != null) result &= repositoryValidator.validateComposedStructure_prohibitProvidingDelegationConnectorDuplicates(system, diagnostics, context);
		if (result || diagnostics != null) result &= repositoryValidator.validateComposedStructure_prohibitRequiringDelegationConnectorDuplicates(system, diagnostics, context);
		if (result || diagnostics != null) result &= repositoryValidator.validateComposedStructure_prohibitAssemblyConnectorDuplicates(system, diagnostics, context);
		if (result || diagnostics != null) result &= repositoryValidator.validateInterfaceProvidingEntity_AtMostOneBlackBoxBehaviorPerProvidedService(system, diagnostics, context);
		if (result || diagnostics != null) result &= repositoryValidator.validateInterfaceProvidingRequiringEntity_AtMostOneCoarseGrainedBehaviorPerProvidedService(system, diagnostics, context);
		if (result || diagnostics != null) result &= validateSystem_SystemMustHaveAtLeastOneInterfaceProvidingRole(system, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SystemMustHaveAtLeastOneInterfaceProvidingRole constraint of '<em>System</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String SYSTEM__SYSTEM_MUST_HAVE_AT_LEAST_ONE_INTERFACE_PROVIDING_ROLE__EEXPRESSION = "not self.interfaceProvidingRoles->isEmpty()";

	/**
	 * Validates the SystemMustHaveAtLeastOneInterfaceProvidingRole constraint of '<em>System</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSystem_SystemMustHaveAtLeastOneInterfaceProvidingRole(tools.descartes.dml.mm.applicationlevel.system.System system, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(SystemPackage.Literals.SYSTEM,
				 system,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SystemMustHaveAtLeastOneInterfaceProvidingRole",
				 SYSTEM__SYSTEM_MUST_HAVE_AT_LEAST_ONE_INTERFACE_PROVIDING_ROLE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateStatisticalModel(StatisticalModel statisticalModel, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(statisticalModel, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(statisticalModel, diagnostics, context);
		if (result || diagnostics != null) result &= servicebehaviorValidator.validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(statisticalModel, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMARSModel(MARSModel marsModel, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(marsModel, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(marsModel, diagnostics, context);
		if (result || diagnostics != null) result &= servicebehaviorValidator.validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(marsModel, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBasisFunction(BasisFunction basisFunction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(basisFunction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateConstant(Constant constant, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(constant, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateHinge(Hinge hinge, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(hinge, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateHingeProduct(HingeProduct hingeProduct, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(hingeProduct, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateVariableReference(VariableReference variableReference, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(variableReference, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateWorkloadIntensity(WorkloadIntensity workloadIntensity, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(workloadIntensity, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateWEKAModel(WEKAModel wekaModel, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(wekaModel, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(wekaModel, diagnostics, context);
		if (result || diagnostics != null) result &= servicebehaviorValidator.validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(wekaModel, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSide(Side side, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return true;
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //SystemValidator
