/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package tools.descartes.dml.perfdatarepo.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import tools.descartes.dml.core.impl.EntityImpl;
import tools.descartes.dml.perfdatarepo.MeasuredEntity;
import tools.descartes.dml.perfdatarepo.MetricType;
import tools.descartes.dml.perfdatarepo.MetricValue;
import tools.descartes.dml.perfdatarepo.PerfdatarepoPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Metric Value</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dml.perfdatarepo.impl.MetricValueImpl#getMeasuredEntity <em>Measured Entity</em>}</li>
 *   <li>{@link tools.descartes.dml.perfdatarepo.impl.MetricValueImpl#getMetricType <em>Metric Type</em>}</li>
 *   <li>{@link tools.descartes.dml.perfdatarepo.impl.MetricValueImpl#getValue <em>Value</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MetricValueImpl extends EntityImpl implements MetricValue {
	/**
	 * The cached value of the '{@link #getMeasuredEntity() <em>Measured Entity</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMeasuredEntity()
	 * @generated
	 * @ordered
	 */
	protected MeasuredEntity measuredEntity;

	/**
	 * The cached value of the '{@link #getMetricType() <em>Metric Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMetricType()
	 * @generated
	 * @ordered
	 */
	protected MetricType metricType;

	/**
	 * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValue()
	 * @generated
	 * @ordered
	 */
	protected static final double VALUE_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getValue() <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValue()
	 * @generated
	 * @ordered
	 */
	protected double value = VALUE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MetricValueImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PerfdatarepoPackage.Literals.METRIC_VALUE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MeasuredEntity getMeasuredEntity() {
		if (measuredEntity != null && measuredEntity.eIsProxy()) {
			InternalEObject oldMeasuredEntity = (InternalEObject)measuredEntity;
			measuredEntity = (MeasuredEntity)eResolveProxy(oldMeasuredEntity);
			if (measuredEntity != oldMeasuredEntity) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PerfdatarepoPackage.METRIC_VALUE__MEASURED_ENTITY, oldMeasuredEntity, measuredEntity));
			}
		}
		return measuredEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MeasuredEntity basicGetMeasuredEntity() {
		return measuredEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMeasuredEntity(MeasuredEntity newMeasuredEntity) {
		MeasuredEntity oldMeasuredEntity = measuredEntity;
		measuredEntity = newMeasuredEntity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PerfdatarepoPackage.METRIC_VALUE__MEASURED_ENTITY, oldMeasuredEntity, measuredEntity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetricType getMetricType() {
		if (metricType != null && metricType.eIsProxy()) {
			InternalEObject oldMetricType = (InternalEObject)metricType;
			metricType = (MetricType)eResolveProxy(oldMetricType);
			if (metricType != oldMetricType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PerfdatarepoPackage.METRIC_VALUE__METRIC_TYPE, oldMetricType, metricType));
			}
		}
		return metricType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetricType basicGetMetricType() {
		return metricType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMetricType(MetricType newMetricType) {
		MetricType oldMetricType = metricType;
		metricType = newMetricType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PerfdatarepoPackage.METRIC_VALUE__METRIC_TYPE, oldMetricType, metricType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setValue(double newValue) {
		double oldValue = value;
		value = newValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PerfdatarepoPackage.METRIC_VALUE__VALUE, oldValue, value));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PerfdatarepoPackage.METRIC_VALUE__MEASURED_ENTITY:
				if (resolve) return getMeasuredEntity();
				return basicGetMeasuredEntity();
			case PerfdatarepoPackage.METRIC_VALUE__METRIC_TYPE:
				if (resolve) return getMetricType();
				return basicGetMetricType();
			case PerfdatarepoPackage.METRIC_VALUE__VALUE:
				return getValue();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PerfdatarepoPackage.METRIC_VALUE__MEASURED_ENTITY:
				setMeasuredEntity((MeasuredEntity)newValue);
				return;
			case PerfdatarepoPackage.METRIC_VALUE__METRIC_TYPE:
				setMetricType((MetricType)newValue);
				return;
			case PerfdatarepoPackage.METRIC_VALUE__VALUE:
				setValue((Double)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PerfdatarepoPackage.METRIC_VALUE__MEASURED_ENTITY:
				setMeasuredEntity((MeasuredEntity)null);
				return;
			case PerfdatarepoPackage.METRIC_VALUE__METRIC_TYPE:
				setMetricType((MetricType)null);
				return;
			case PerfdatarepoPackage.METRIC_VALUE__VALUE:
				setValue(VALUE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PerfdatarepoPackage.METRIC_VALUE__MEASURED_ENTITY:
				return measuredEntity != null;
			case PerfdatarepoPackage.METRIC_VALUE__METRIC_TYPE:
				return metricType != null;
			case PerfdatarepoPackage.METRIC_VALUE__VALUE:
				return value != VALUE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (value: ");
		result.append(value);
		result.append(')');
		return result.toString();
	}

} //MetricValueImpl
